import java.util.Scanner;

public class PrevendoTriangulos {

	public static void main(String[] args) {

		Scanner scan = new Scanner(System.in);

		int nCasosTeste = scan.nextInt();

		// String que guarda a resposta de todos os casos de teste para imprimir
		// ao final
		String r = "";

		// Lao que pega os dados em cada caso de teste e processa-os
		for (int i = 0; i < nCasosTeste; i++) {

			// quantidade de pontos que serao analisados no caso de teste atual
			int nPontos = scan.nextInt();

			// vetores que armazenam as coordenadas x e y passadas na entrada de
			// cada caso de teste
			int[] x = new int[nPontos];
			int[] y = new int[nPontos];

			// Laco que recebe os pontos x e y do caso de teste atual e
			// armazena-os nos vetores auxiliares
			for (int j = 0; j < nPontos; j++) {
				x[j] = scan.nextInt();
				y[j] = scan.nextInt();
			}

			// Chamada da funcao que realiza o processamento da entrada, produz
			// a saida atual na forma de String e concatena com a String final
			r += executar(nPontos, x, y) + "\n";

		}

		System.out.print(r);

	}

	public static int executar(int n, int[] x, int[] y) {

		int cont = 0;

		/*
		 * Nesses tres lacos encadeados sao feitas todas as combinacoes
		 * possiveis de triangulos para o conjunto de pontos fornecido. No laco
		 * mais externo, define-se o primeiro pilar, no laco do meio, o segundo
		 * pilar e no laco mais interno, o terceiro pilar.
		 **/
		for (int i = 0; i < n - 2; i++) {

			// Laco que
			for (int j = i + 1; j < n - 1; j++) {
				for (int k = j + 1; k < n; k++) {

					// Calcula-se a distancia entre cada um dos pilares e os
					// outros tres para saber o tamanho dos lados do triangulo
					double d1 = Math.sqrt(Math.pow(Math.abs(x[i] - x[j]), 2) + Math.pow(Math.abs(y[i] - y[j]), 2));
					double d2 = Math.sqrt(Math.pow(Math.abs(x[i] - x[k]), 2) + Math.pow(Math.abs(y[i] - y[k]), 2));
					double d3 = Math.sqrt(Math.pow(Math.abs(x[j] - x[k]), 2) + Math.pow(Math.abs(y[j] - y[k]), 2));
					
					//Condicao de existencia de um triangulo.
					if (d1 < d2 + d3 && d2 < d1 + d3 && d3 < d1 + d2) {
						 //Caso seja possivel formar um triangulo, incrementa-se o contador.
						cont++;
					}
				}
			}
		}

		return cont;

	}

}
